local missingParameter = {}
 
STAT_CRIT_DMG_MAG=43
STAT_CRIT_DMG_PHIS=45
STAT_BLOCK_COST=14
STAT_BLOCK_MITIGATION=32

EsoStrings[SI_DERIVEDSTATS43] ="Spell Critical Damage"
EsoStrings[SI_DERIVEDSTATS45] ="Weapon Critical Damage"
EsoStrings[SI_DERIVEDSTATS14] ="Block Cost"
EsoStrings[SI_DERIVEDSTATS32] ="Block Mitigation"

local StrMag= "The percentage of increased damage from critically attacking an enemy with magic abilities."
local StrWep= "The percentage of increased damage from critically attacking an enemy with physical abilities."
local BlockCost= "The cost of blocking changes with your Level and is a flat amount for each Level."
local BlockMit= "The percentage of damage reduced when block."

ZO_CreateStringId("SI_STAT_TOOLTIP_CRIT_DMG_MAG", StrMag)
ZO_CreateStringId("SI_STAT_TOOLTIP_CRIT_DMG_PHIS", StrWep)
ZO_CreateStringId("SI_STAT_TOOLTIP_STAT_BLOCK_COST", BlockCost)
ZO_CreateStringId("SI_STAT_TOOLTIP_STAT_BLOCK_MITIGATION", BlockMit)

ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_CRIT_DMG_MAG]=SI_STAT_TOOLTIP_CRIT_DMG_MAG
ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_CRIT_DMG_PHIS]=SI_STAT_TOOLTIP_CRIT_DMG_PHIS
ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_BLOCK_COST]=SI_STAT_TOOLTIP_STAT_BLOCK_COST
ZO_STAT_TOOLTIP_DESCRIPTIONS[STAT_BLOCK_MITIGATION]=SI_STAT_TOOLTIP_STAT_BLOCK_MITIGATION

-- Calc Function

local function GetProtectBonus()
	local protect={["Minor Protection"]=5,["Minor Aegis"]=5,["Major Protection"]=10,["Major Aegis"]=10}
	local protect_bonus=0
	for i=1, GetNumBuffs("player") do
		local name=GetUnitBuffInfo("player",i)
		if protect[name] then protect_bonus=protect_bonus+protect[name] end
	end
	return protect_bonus
end

local function GetDivinesBonus()
	local worn={0,2,3,6,8,9,16}
	local bonus=0
	for _,i in pairs(worn) do
		local x, y=GetItemLinkTraitInfo(GetItemLink(BAG_WORN,i) )
		if x==ITEM_TRAIT_TYPE_ARMOR_DIVINES then bonus=bonus+(tonumber(string.sub(y,string.find(y, "%d.%d"))) or 0) end
	end
	return bonus
end

local function GetCritDamage()
	--buff_bonus
	local forces={["Major Force"]=20,["Minor Force"]=10}
	local buff_bonus=0
	for i=1, GetNumBuffs("player") do
		local name,_,_,_,_,_,_,_,_,_,id=GetUnitBuffInfo("player",i)
		if forces[name] then buff_bonus=buff_bonus+forces[name] end
		if id==13984 then buff_bonus=buff_bonus+math.floor(9*(1+GetDivinesBonus()/100)) end
	end

	--class_bonus
	local class=GetUnitClassId("player")
	local class_bonus=0
	local ability_slotted=0
	local ability={}
	if class==3 or class==6 then	--NB or Templar
		for i=1, 6 do
			local id=GetSkillAbilityId(1,1,i)
			ability[id]=true	--nb assasination abilities or templar aedric spear abilities
		end
		for i=3, 8 do
			if ability[GetSlotBoundId(i)] then ability_slotted=1 end
		end
		local passive_level=GetSkillAbilityUpgradeInfo(1,1,(class==3 and 10 or 7))
		class_bonus=5*passive_level*ability_slotted
	end
	local race_bonus=0
	if GetUnitRaceId("player")==9 then	--Khajiit
		local passive_level=GetSkillAbilityUpgradeInfo(7,1,4)
		race_bonus=math.floor(passive_level*3.4)
	end

	local points_s=GetNumPointsSpentOnChampionSkill(5, 2)*0.01	--Points in precise strikes
	local points_m=GetNumPointsSpentOnChampionSkill(7, 3)*0.01	--Points in elfborn
	return 50+race_bonus+class_bonus+buff_bonus+math.floor(0.25*points_s*(2-points_s)*100),50+race_bonus+class_bonus+buff_bonus+math.floor(0.25*points_m*(2-points_m)*100)
end

local function GetProcSetPenetration()
	local pair=GetActiveWeaponPairInfo()
	local worn={(pair==1 and EQUIP_SLOT_MAIN_HAND or EQUIP_SLOT_BACKUP_MAIN),(pair==1 and EQUIP_SLOT_OFF_HAND or EQUIP_SLOT_BACKUP_OFF),EQUIP_SLOT_BACKUP_OFF,EQUIP_SLOT_HEAD,EQUIP_SLOT_SHOULDERS,EQUIP_SLOT_CHEST,EQUIP_SLOT_WAIST,EQUIP_SLOT_LEGS,EQUIP_SLOT_HAND,EQUIP_SLOT_FEET}
	local set={["Twice-Fanged Serpent"]=true,}	--["Night Mother's Gaze"]=true,["Sunderflame"]=true}
	local penetr=0
	for _,i in pairs(worn) do
		local link=GetItemLink(BAG_WORN,i)
		local hasSet,setName,_,numEquipped,maxEquipped=GetItemLinkSetInfo(link)
		if hasSet and set[setName] and maxEquipped==numEquipped then
			local _,desc=GetItemLinkSetBonusInfo(link, false, 4)
			local a1,a2=string.find(desc, "%d%d%d+")
			if a1 then
				local s1,s2=string.find(desc, "%d%d%d+",a2+1)
				local value=tonumber(s1 and string.sub(desc,s1,s2) or string.sub(desc,a1,a2))
				if value then penetr=value end
			end
			if setName=="Twice-Fanged Serpent" then penetr=penetr*5 end
--			d(setName..": "..penetr)
			break
		end
	end
	return penetr
end

local function GetBlockCost()
	local passive=0
	local ability=0
	local mitigation=0
	local pair=GetActiveWeaponPairInfo()
	local function Get_sturdy_bonus()
		local worn={(pair==1 and EQUIP_SLOT_OFF_HAND or EQUIP_SLOT_BACKUP_OFF),EQUIP_SLOT_HEAD,EQUIP_SLOT_SHOULDERS,EQUIP_SLOT_CHEST,EQUIP_SLOT_WAIST,EQUIP_SLOT_LEGS,EQUIP_SLOT_HAND,EQUIP_SLOT_FEET}
		local bonus=0
		local footman=false
		for _,i in pairs(worn) do
			local link=GetItemLink(BAG_WORN,i)
			local x, y=GetItemLinkTraitInfo(link)
			if x==ITEM_TRAIT_TYPE_ARMOR_STURDY then
				local s1,s2=string.find(y, "%d.%d")
				local value=tonumber(s1 and string.sub(y,s1,s2) or string.sub(y,string.find(y, "[0-9]+")))
				if value then bonus=bonus+value end
			end
			local hasSet,setName,_,numEquipped,maxEquipped=GetItemLinkSetInfo(link)
			if hasSet and setName=="Footman's Fortune" and maxEquipped==numEquipped then footman=true end
		end
		if footman then mitigation=mitigation+8 end
		return 1-bonus/100
	end

	local function Get_jewelry_bonus()
		local worn={EQUIP_SLOT_NECK,EQUIP_SLOT_RING1,EQUIP_SLOT_RING2}
		local bonus=0
		for _,i in pairs(worn) do
			local name,enchant=select(2,GetItemLinkEnchantInfo(GetItemLink(BAG_WORN,i)))
			if name=="Bracing Enchantment" then
				local s1,s2=string.find(enchant, "[0-9]+")
				if s1 then
					local value=tonumber(string.sub(enchant,s1,s2))
					if value then bonus=bonus+value end
				end
			end
		end
		return bonus
	end

	local class=GetUnitClassId("player")
	if class==1 then		--DK
		mitigation=mitigation+GetSkillAbilityUpgradeInfo(1,2,7)*5
	elseif class==6 then	--Templar
		local ability_slotted=false
		local ability={}
		for i=1, 6 do
			local id=GetSkillAbilityId(1,1,i)
			ability[id]=true	--templar aedric spear abilities
		end
		for i=3, 8 do
			if ability[GetSlotBoundId(i)] then ability_slotted=true end
		end
		if ability_slotted then mitigation=mitigation+math.floor(GetSkillAbilityUpgradeInfo(1,1,8)*7.5) end
	end

	if GetItemWeaponType(BAG_WORN,(pair==1 and EQUIP_SLOT_MAIN_HAND or EQUIP_SLOT_BACKUP_MAIN))==WEAPONTYPE_FROST_STAFF then
		passive=GetSkillAbilityUpgradeInfo(2,5,10)*18
		mitigation=mitigation+GetSkillAbilityUpgradeInfo(2,5,10)*10
	elseif GetItemWeaponType(BAG_WORN,(pair==1 and EQUIP_SLOT_OFF_HAND or EQUIP_SLOT_BACKUP_OFF))==WEAPONTYPE_SHIELD then
		passive=GetSkillAbilityUpgradeInfo(2,2,7)*18
		mitigation=mitigation+GetSkillAbilityUpgradeInfo(2,2,8)*10
		local id=GetSkillAbilityId(2,2,4)
		for i=3, 7 do
			if id==GetSlotBoundId(i) then
				ability=ability+8
				mitigation=mitigation+8
			end
		end
	end
	passive,ability=1-passive/100,1-ability/100

	local points=GetNumPointsSpentOnChampionSkill(8, 3)*0.01 points=1-math.floor(0.25*points*(2-points)*100)/100
	local cost=math.floor((1730*points-Get_jewelry_bonus())*Get_sturdy_bonus()*passive*ability)
--	d("Mitigation: "..mitigation,"Champ: "..points,"Sturdy: "..Get_sturdy_bonus(),"Jevelry: "..Get_jewelry_bonus(),"Passive: "..passive,"Ability: "..ability)
	return cost,(100-.5*(100-mitigation))
end

-- Dicplay

local function format_number(n)
	return ZO_LocalizeDecimalNumber(n)
end

local AddStatRowOrg=ZO_Stats.AddStatRow
local missingParameter
local function GetStat(stat)
	if stat==STAT_CRIT_DMG_PHIS or stat==STAT_CRIT_DMG_MAG then
		local bonus_p,bonus_m=GetCritDamage()
		return stat==STAT_CRIT_DMG_PHIS and bonus_p or bonus_m
	elseif stat==STAT_BLOCK_COST or stat==STAT_BLOCK_MITIGATION then
		local cost,mitigation=GetBlockCost()
		return stat==STAT_BLOCK_COST and cost or mitigation
	elseif stat==STAT_SPELL_RESIST or stat==STAT_PHYSICAL_RESIST or stat==STAT_SPELL_PENETRATION or stat==STAT_PHYSICAL_PENETRATION then
		local value=GetPlayerStat(stat)
		local perc=math.floor(value/66.2)/10
		if stat==STAT_PHYSICAL_PENETRATION then
			value=value+GetProcSetPenetration()
			perc=math.floor(value/66.2)/10
		elseif stat==STAT_SPELL_RESIST or stat==STAT_PHYSICAL_RESIST then
			local bonus=GetProtectBonus()
			perc=math.min(50,math.floor(value/66.2)/10)..(bonus>0 and "+"..bonus or "")
		end
		return format_number(value).." |cBBBBBB("..perc.."%)|r"
	elseif stat==STAT_HEALTH_MAX or stat==STAT_MAGICKA_MAX or stat==STAT_STAMINA_MAX then
		return format_number(GetPlayerStat(stat))
	else
		return GetPlayerStat(stat)
	end
end

ZO_Stats.AddStatRow=function(...)
	missingParameter=(select(1,...))
	local ret=AddStatRowOrg(...)
	ZO_Stats.AddStatRow=AddStatRowOrg
	return ret
end

ZO_StatEntry_Keyboard.GetDisplayValue=function(self,targetValue)
	local value=targetValue or GetStat(self.statType)
	if self.statType==STAT_CRITICAL_STRIKE or self.statType==STAT_SPELL_CRITICAL then
		return zo_strformat(SI_STAT_VALUE_PERCENT, GetCriticalStrikeChance(value))
	elseif self.statType==STAT_CRIT_DMG_PHIS or self.statType==STAT_CRIT_DMG_MAG or self.statType==STAT_BLOCK_MITIGATION then
		return zo_strformat(SI_STAT_VALUE_PERCENT, value)
	else
		return tostring(value)
	end
end

local CreateAttributesSectionOrg=ZO_Stats.CreateAttributesSection
ZO_Stats.CreateAttributesSection=function(...)
	local ret=CreateAttributesSectionOrg(...)
	ZO_Stats.SetNextControlPadding(missingParameter,20)
	ZO_Stats.AddStatRow(missingParameter,STAT_BLOCK_COST,STAT_BLOCK_MITIGATION)
	ZO_Stats.SetNextControlPadding(missingParameter,20)
	ZO_Stats.AddStatRow(missingParameter,STAT_SPELL_PENETRATION,STAT_PHYSICAL_PENETRATION)
	ZO_Stats.SetNextControlPadding(missingParameter,0)
	ZO_Stats.AddStatRow(missingParameter,STAT_CRIT_DMG_MAG,STAT_CRIT_DMG_PHIS)
	ZO_Stats.SetNextControlPadding(missingParameter,20)
	return ret
end